package com.cxytiandi.spider_java;

import java.util.ArrayList;
import java.util.List;

import com.mongodb.BasicDBObject;
import com.mongodb.DBObject;
import com.mongodb.MongoClient;
import com.mongodb.MongoClientOptions;
import com.mongodb.ServerAddress;
import com.mongodb.client.MongoCollection;
import com.mongodb.client.MongoDatabase;

import us.codecraft.webmagic.Page;
import us.codecraft.webmagic.Site;
import us.codecraft.webmagic.Spider;
import us.codecraft.webmagic.processor.PageProcessor;
import us.codecraft.webmagic.selector.Selectable;
/**
 * 爬当当图书信息
 * @author yinjihuan
 *
 */
public class BookPageProcess implements PageProcessor {
	
	private Site site = Site.me().setRetrySleepTime(3);
	
	private static MongoCollection<DBObject> collection = null;
	
	static {
		MongoClientOptions options = MongoClientOptions.builder().connectTimeout(60000).build();
		
		MongoClient client = new MongoClient(new ServerAddress("localhost", 27017), options);
		
		MongoDatabase db = client.getDatabase("test");
		
		collection = db.getCollection("book_info", DBObject.class);	
	}
	
	@Override
	public Site getSite() {
		return site;
	}

	@Override
	public void process(Page page) {
		List<BasicDBObject> documents = new ArrayList<>();
		List<Selectable> nodes = page.getHtml().$(".tushu").nodes();
		for (Selectable node : nodes) {
			Selectable nameNode = node.$(".name a");
			Selectable imgNode = node.$(".cover img");
			String title = nameNode.xpath("a/text()").get();
			String href = nameNode.xpath("a//@href").get();
			String img = imgNode.xpath("img//@src").get();
			System.out.println(title + "\t" + href + "\t" + img);
			BasicDBObject document = new BasicDBObject();
			document.append("title", title).append("href", href).append("img", img);
			documents.add(document);
		}
		collection.insertMany(documents);
	}
	
	public static void main(String[] args) {
		List<String> urls = new ArrayList<>();
		for (int i = 1; i <= 10; i++) {
			urls.add("http://book.dangdang.com/list/newRelease_C01.03_P"+i+".htm");
		}
		Spider.create(new BookPageProcess()).addUrl(urls.toArray(new String[urls.size()])).thread(3).run();
	}

}
