package com.cxytiandi.spider_java;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 * IP池构建
 * @author 尹吉欢  QQ:1304489315
 */
public class IpPoolTets {
	public static void main(String[] args) {
		List<Map<String, Integer>> list = getIps();
		for (int i = 0; i < 100; i++) {
			Map<String, Integer> map = random(list);
			String ip = new ArrayList<>(map.keySet()).get(0);
			int port = map.get(ip);
			System.out.println(ip + "\t" + port);
			String html = HttpClient.get("http://cxytiandi.com", "utf-8", ip, port);
			System.err.println(html);
		}
	}
	
	private static Map<String, Integer> random(List<Map<String, Integer>> list) {
		return list.get(new Random().nextInt(list.size()));
	}
	
	private static List<Map<String, Integer>> getIps() {
		List<Map<String, Integer>> list = new ArrayList<>();
		String html = HttpClient.get("http://www.xicidaili.com/nn", "utf-8");
		Element table = Jsoup.parse(html).getElementById("ip_list");
		Elements trs = table.select("tr");
		int i = 0;
		for (Element tr : trs) {
			if (i > 0) {
				Elements tds = tr.select("td");
				Map<String, Integer> map = new HashMap<>();
				//System.out.println(tds.get(1).text() + "\t" + tds.get(2).text());
				map.put(tds.get(1).text(), Integer.parseInt(tds.get(2).text()));
				list.add(map);
			}
			i++;
		}
		return list;
	}
}
