package com.cxytiandi.spider_java;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

import org.jsoup.Jsoup;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

/**
 * 多线程抓取
 * @author 尹吉欢  QQ:1304489315
 */
public class ThreadPollTest {
	private static ExecutorService pool = Executors.newFixedThreadPool(10);
	
	public static void main(String[] args) {
		CountDownLatch latch  = new CountDownLatch(100);
		for (int j = 1; j <= 100; j++) {
			final int page = j;
			pool.execute(new Runnable() {
				@Override
				public void run() {
					try {
						String html = HttpClient.get("http://www.xicidaili.com/nn/"+page, "utf-8");
						if (html == null) {
							return;
						}
						Element table = Jsoup.parse(html).getElementById("ip_list");
						Elements trs = table.select("tr");
						int i = 0;
						for (Element tr : trs) {
							if (i > 0) {
								Elements tds = tr.select("td");
								System.out.println(tds.get(1).text() + "\t" + tds.get(2).text());
							}
							i++;
						}
					} finally {
						latch.countDown();
					}
				}
			});
		}
		try {
			latch.await();
			pool.shutdown();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("end....");
		//根据抓取的数据做处理
		
	}
	
}
